
    MEMBER()
    MAP
        INCLUDE('sRE.INC')
    END

    INCLUDE('cRE.INC')
    INCLUDE('keycodes.clw')
    INCLUDE('PRNPROP.CLW')

!- Create the Rich Edit control, inheriting attributes of TextBoxFEQ
cRichEdit.Init                            PROCEDURE(LONG TextBoxFEQ)
x           UNSIGNED(0)
y           UNSIGNED(0)
w           UNSIGNED(0)
h           UNSIGNED(0)
pixelstate  STRING(1),AUTO
Font        STRING(20)
PointSize   LONG(0)
b           BYTE(FALSE)
u           BYTE(FALSE)
i           BYTE(FALSE)
REFEQ       LONG(0)
    CODE
    ASSERT(TextBoxFEQ)
    REFEQ = TextBoxFEQ
    pixelstate = 0{PROP:Pixels}
    0{PROP:Pixels} = '1'
    x = REFEQ{PROP:XPOS}
    y = REFEQ{PROP:YPOS}
    w = REFEQ{PROP:WIDTH}
    h = REFEQ{PROP:HEIGHT}
    Font = REFEQ{PROP:Font,1}
    PointSize = REFEQ{PROP:Font,2}
    0{PROP:Pixels} = pixelstate
    IF BAND(REFEQ{PROP:Font,4},FONT:Bold)
        b = TRUE
    END
    IF BAND(REFEQ{PROP:Font,4},FONT:Italic)
        i = TRUE
    END
    IF BAND(REFEQ{PROP:Font,4},FONT:Underline)
        u = TRUE
    END
    DESTROY(REFEQ)
    SELF.hWndRE = RECreate(0{PROP:ClientHandle},SYSTEM{PROP:AppInstance})
    ASSERT(SELF.hWndRE)
    SELF.SetFont(Font,1)
    SELF.SetPointSize(PointSize,1)
    IF b
        SELF.ToggleBold(1)
    END
    IF i
        SELF.ToggleItalic(1)
    END
    IF u
        SELF.ToggleUnderline(1)
    END
    SELF.Move(x,y,w,h)

!- Must be called to destroy the Rich Edit control.
cRichEdit.Kill                            PROCEDURE
    CODE
    IF SELF.hWndRE
        REDestroy(SELF.hWndRE)
    END

!- Pass EVENT() along to this method for some default behavior (none currently).
cRichEdit.TakeEvent                       PROCEDURE(LONG e)
    CODE
    ASSERT(SELF.hWndRE>0)

!- Call font selection function. If All is specified,
!- formatting is applied to all text.
cRichEdit.AskFont                         PROCEDURE(<BYTE All>)
ba  BYTE(0)
TypeFace        CSTRING(20)
FontSize        LONG
FontColor       LONG
FontStyle       LONG
b           BYTE(FALSE)
u           BYTE(FALSE)
i           BYTE(FALSE)
    CODE
    ASSERT(SELF.hWndRE>0)
    ba = All
    IF FONTDIALOG(,TypeFace,FontSize,FontColor,FontStyle,0)
        RESetFont(SELF.hWndRE,TypeFace,ba)
        RESetPointSize(SELF.hWndRE,Fontsize,ba)
        IF BAND(FontStyle,FONT:Bold)
            b = TRUE
        END
        IF BAND(FontStyle,FONT:Italic)
            i = TRUE
        END
        IF BAND(FontStyle,FONT:Underline)
            u = TRUE
        END
        IF b
            SELF.ToggleBold(ba)
        END
        IF i
            SELF.ToggleItalic(ba)
        END
        IF u
            SELF.ToggleUnderline(ba)
        END
        IF FontColor
            RESetFontColor(SELF.hWndRE,FontColor,ba)
        END
    END

!- Call printer dialog to print contents of Rich Edit control.
cRichEdit.AskPrint                        PROCEDURE()
Report REPORT,AT(500,1500,7500,8750),PAPER(1),PRE(RPT),FONT('Arial',10,,FONT:regular),THOUS
Detail   DETAIL
         END
     END
driver  CSTRING(30)
device  CSTRING(30)

    CODE
    ASSERT(SELF.hWndRE>0)
    IF PRINTERDIALOG()
        OPEN(report)
        driver = Report{PROPPRINT:Driver}
        device = report{PROPPRINT:Device}
        REPrint(SELF.hWndRE,driver,device)
        CLOSE(report)
    END

!- Indent selected text to the right, unless Left is specified.
cRichEdit.Indent                          PROCEDURE(<BYTE Left>)
b   BYTE(0)
    CODE
    ASSERT(SELF.hWndRE>0)
    b = Left
    REIndent(SELF.hWndRE,b)

!- Toggles whether or not the Rich Edit control uses BULLETS.
cRichedit.ToggleBullet                    PROCEDURE()
    CODE
    ASSERT(SELF.hWndRE>0)
    REToggleBullet(SELF.hWndRE)

!- Returns TRUE if the Rich Edit control has input focus.
cRichEdit.HasFocus                        PROCEDURE()
    CODE
    ASSERT(SELF.hWndRE>0)
    IF REHasFocus(SELF.hWndRE)
        RETURN(TRUE)
    ELSE
        RETURN(FALSE)
    END

!- Loads the RTF contents of FILE f into the Rich Edit control.
!- Returns zero if successful, non-zero for failure.
cRichEdit.LoadFromFile                    PROCEDURE(STRING f)
fn              CSTRING(255)
ReturnValue     BYTE(FALSE)
    CODE
    ASSERT(SELF.hWndRE>0)
    IF NOT LEN(CLIP(f))
        RETURN(1)
    END
    fn = CLIP(f)
    ReturnValue = RELoadFromFile(SELF.hWndRE,fn)
    RETURN(ReturnValue)

!- Saves the RTF contents of the Rich Edit control into FILE f.
!- Returns zero if successful, non-zero for failure.
cRichEdit.SaveToFile                      PROCEDURE(STRING f)
fn              CSTRING(255)
ReturnValue     BYTE(FALSE)
    CODE
    ASSERT(SELF.hWndRE>0)
    IF NOT LEN(CLIP(f))
        RETURN(1)
    END
    fn = CLIP(f)
    ReturnValue = RESaveToFile(SELF.hWndRE,fn)
    RETURN(ReturnValue)

!- Move the control (measurements in pixels).  Typically called after the Init()
!- method which creates the control with 0 size.
cRichEdit.Move                            PROCEDURE(LONG x, LONG y, LONG w, LONG h)
    CODE
    ASSERT(SELF.hWndRE>0)
    REMove(SELF.hWndRE,x,y,w,h)

!- Put the contents of a CSTRING into the Rich Edit control.
!- NOTE: The current implementation corrupts the passed CSTRING.
cRichEdit.StreamIn                        PROCEDURE(*CSTRING s)
    CODE
    ASSERT(SELF.hWndRE>0)
    REStreamIN(SELF.hWndRE,s)

!- Copy the contents of the Rich Edit control into a CSTRING.
cRichEdit.StreamOut                       PROCEDURE(*CSTRING s)
    CODE
    ASSERT(SELF.hWndRE>0)
    REStreamOUT(SELF.hWndRE,s)

!- Set text alignment in Rich Edit control.  The following values apply
!- a<0 right alignment
!- a=0(or NULL) left alignment
!- a>0 center alignment
cRichEdit.SetAlignment                    PROCEDURE(<LONG a>)
    CODE
    ASSERT(SELF.hWndRE>0)
    IF NOT a
        a = 0
    END
    RESetAlign(SELF.hWndRE,a)

!- Set imput focus to the Rich Edit control.
cRichEdit.SetFocus                        PROCEDURE()
    CODE
    ASSERT(SELF.hWndRE>0)
    RESetFocus(SELF.hWndRE)

!- Apply a font to the Rich Edit control.  If All is specified,
!- formatting is applied to all text.
cRichEdit.SetFont                         PROCEDURE(STRING f, <BYTE All>)
b   BYTE(0)
fn  CSTRING(20)
    CODE
    ASSERT(SELF.hWndRE>0)
    fn = CLIP(f)
    b = All
    RESetFont(SELF.hWndRE,fn,b)

!- Apply a point size to the Rich Edit control.  If All is specified,
!- formatting is applied to all text.
cRichEdit.SetPointSize                    PROCEDURE(LONG ps, <BYTE All>)
b   BYTE(0)
    CODE
    ASSERT(SELF.hWndRE>0)
    b = All
    RESetPointSize(SELF.hWndRE,ps,b)

!- Toggles whether or not the Rich Edit control is readonly (default is non-readonly)
cRichEdit.ToggleReadOnly                     PROCEDURE()
    CODE
    ASSERT(SELF.hWndRE>0)
    REToggleReadOnly(SELF.hWndRE)

!- Forces a tab character to be sent to the Rich Edit control.
!- Currently, the Rich Edit control will not receive a tab character
!- (the default window action of switching focus to another field is used).
!- Typically, another key is ALERTed (such as Ctrl-T or Ctrl-Tab)
!- and this method is called to force a tab character in the Rich Edit control.
cRichEdit.ForceTab                         PROCEDURE()
    CODE
    ASSERT(SELF.hWndRE>0)
    REForceTab(SELF.HwndRE)

!- Toggles whether or not the Rich Edit control uses BOLD.
!- If All is specified, this is applied to all text.
cRichEdit.ToggleBold                      PROCEDURE(<BYTE All>)
b   BYTE(0)
    CODE
    ASSERT(SELF.hWndRE>0)
    b = All
    REToggleBold(SELF.hWndRE,b)

!- Toggles whether or not the Rich Edit control uses ITALIC.
!- If All is specified, this is applied to all text.
cRichEdit.ToggleItalic                    PROCEDURE(<BYTE All>)
b   BYTE(0)
    CODE
    ASSERT(SELF.hWndRE>0)
    b = All
    REToggleItalic(SELF.hWndRE,b)

!- Toggles whether or not the Rich Edit control uses UNDERLINE.
!- If All is specified, this is applied to all text.
cRichEdit.ToggleUnderline                 PROCEDURE(<BYTE All>)
b   BYTE(0)
    CODE
    ASSERT(SELF.hWndRE>0)
    b = All
    REToggleUnderline(SELF.hWndRE,b)